## ghc 7.0.4

=== Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

ifeq "$(wildcard distrib/)" ""

# We're in a bindist

.PHONY: default
default:
	@echo 'Run "make install" to install'
	@false

.PHONY: install show
install show:
	$(MAKE) -r --no-print-directory -f ghc.mk $@ BINDIST=YES NO_INCLUDE_DEPS=YES

else

default : all
	@:

# For help, type 'make help'
.PHONY: help
help :
	@cat MAKEHELP

ifneq "$(findstring clean,$(MAKECMDGOALS))" ""
-include mk/config.mk
else
include mk/config.mk
ifeq "$(ProjectVersion)" ""
$(error Please run ./configure first)
endif
endif

include mk/custom-settings.mk

# No need to update makefiles for these targets:
REALGOALS=$(filter-out binary-dist binary-dist-prep bootstrapping-files framework-pkg clean clean_% distclean maintainer-clean show help install-docs test fulltest,$(MAKECMDGOALS))

# configure touches certain files even if they haven't changed.  This
# can mean a lot of unnecessary recompilation after a re-configure, so
# here we cache the old versions of these files so we can restore the
# timestamps.
%.old:  %
	@set -x && test -f $@ && cmp -s $< $@ || cp -p $< $@
	touch -r $@ $<


# NB. not the same as saying '%: ...', which doesn't do the right thing:
# it does nothing if we specify a target that already exists.
.PHONY: $(REALGOALS)
$(REALGOALS) all: mk/config.mk.old mk/project.mk.old compiler/ghc.cabal.old
	@echo "===--- updating makefiles phase 0"
	$(MAKE) -r --no-print-directory -f ghc.mk phase=0 just-makefiles
ifneq "$(OMIT_PHASE_1)" "YES"
	@echo "===--- updating makefiles phase 1"
	$(MAKE) -r --no-print-directory -f ghc.mk phase=1 just-makefiles
endif
ifneq "$(OMIT_PHASE_2)" "YES"
	@echo "===--- updating makefiles phase 2"
	$(MAKE) -r --no-print-directory -f ghc.mk phase=2 just-makefiles
endif
ifneq "$(OMIT_PHASE_3)" "YES"
	@echo "===--- updating makefiles phase 3"
	$(MAKE) -r --no-print-directory -f ghc.mk phase=3 just-makefiles
endif
	@echo "===--- finished updating makefiles"
	$(MAKE) -r --no-print-directory -f ghc.mk $@

binary-dist: binary-dist-prep
ifeq "$(mingw32_TARGET_OS)" "1"
	mv bindistprep/*.exe .
endif
	mv bindistprep/*.tar.bz2 .

binary-dist-prep:
ifeq "$(mingw32_TARGET_OS)" "1"
	$(MAKE) -r --no-print-directory -f ghc.mk windows-binary-dist-prep
	$(MAKE) -r --no-print-directory -f ghc.mk windows-installer
else
	rm -f bindist-list
	$(MAKE) -r --no-print-directory -f ghc.mk bindist BINDIST=YES
	$(MAKE) -r --no-print-directory -f ghc.mk unix-binary-dist-prep
endif

clean distclean maintainer-clean:
	$(MAKE) -r --no-print-directory -f ghc.mk $@ CLEANING=YES
	test ! -d testsuite || $(MAKE) -C testsuite $@

$(filter clean_%, $(MAKECMDGOALS)) : clean_% :
	$(MAKE) -r --no-print-directory -f ghc.mk $@ CLEANING=YES

bootstrapping-files show:
	$(MAKE) -r --no-print-directory -f ghc.mk $@

ifeq "$(darwin_TARGET_OS)" "1"
framework-pkg:
	$(MAKE) -C distrib/MacOS $@
endif

# install-docs is a historical target that isn't supported in GHC 6.12. See #3662.
install-docs:
	@echo "The install-docs target is not supported in GHC 6.12.1 and later."
	@echo "'make install' now installs everything, including documentation."
	@exit 1

# If the user says 'make A B', then we don't want to invoke two
# instances of the rule above in parallel:
.NOTPARALLEL:

endif

.PHONY: test
test:
	$(MAKE) -C testsuite/tests/ghc-regress CLEANUP=1 OUTPUT_SUMMARY=../../../testsuite_summary.txt fast

.PHONY: fulltest
fulltest:
	$(MAKE) -C testsuite/tests/ghc-regress CLEANUP=1 OUTPUT_SUMMARY=../../../testsuite_summary.txt

=== utils/Makefile ===
TOP=..
include $(TOP)/mk/boilerplate.mk

ifeq "$(DOING_BIN_DIST)" "YES"
# We're doing a binary-dist, descend into a subset of the dirs.
SUBDIRS = mkdirhier hp2ps parallel unlit
else
ifeq "$(BootingFromHc)" "YES"
SUBDIRS = mkdependC mkdirhier runstdtest genapply genprimopcode unlit
else
SUBDIRS = mkdependC mkdirhier runstdtest hp2ps \
	  parallel unlit genprimopcode genapply
endif
#ifneq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
## lndir doesn't build on Windows
#SUBDIRS += lndir
#endif
endif

ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
SUBDIRS += touchy
endif

# XXX pwd and lndir building disabled for now

# Utils that we don't build by default:
#	nofib-analyse

# Utils that are old and/or bitrotted:
#	stat2resid
#	debugNCG
#	genargs
#	heap-view
#	pvm
#	verbatim
#	ltx
#	hstags

# "heap-view" is not in the list because (a) it requires
#  a Haskell compiler (which you may not have yet), and (b) you are
#  unlikely to want it desperately.  It is easy to build once you have
#  a Haskell compiler and if you want it.

include $(TOP)/mk/target.mk

# genprimopcode is needed to boot in ghc/compiler...
ifneq "$(BootingFromHc)" "YES"
boot ::
	$(MAKE) -C genprimopcode
endif

############################################

# The utils may be built with the bootstrapping compiler, for use during
# the build, or with the stage2 compiler, for installing. Some of them
# are built with both; we can't install the utils built with the
# bootstrapping compiler as they may use different versions of C
# libraries. The reason we use stage2 rather than stage1 is that some
# utils, e.g. haddock, need the GHC API package.

WITH_BOOTSTRAPPING_COMPILER = installPackage ghc-pkg hsc2hs hpc

WITH_STAGE2 = installPackage ghc-pkg hasktags runghc hpc pwd haddock
ifneq "$(NO_INSTALL_HSC2HS)" "YES"
WITH_STAGE2 += hsc2hs
endif

# sort removes duplicates - we don't actually care about the order
WITH_EITHER = $(sort $(WITH_BOOTSTRAPPING_COMPILER) $(WITH_STAGE2))

# We need to build pwd with stage 2, as it goes in bindists, but we
# don't actually want to install it. Likewise the installPackage
# program.
DO_NOT_INSTALL = pwd installPackage

binary-dist: $(foreach P,$(WITH_STAGE2),binary-dist.$P)
ifeq "$(WHERE_AM_I)" ""
	echo "I don't know where I am" >&2
	exit 1
endif
	echo $(WHERE_AM_I)/Makefile >> $(BIN_DIST_LIST)
	set -e; for d in $(SUBDIRS); do $(MAKE) -C $$d binary-dist WHERE_AM_I=$(WHERE_AM_I)/$$d; done

clean:: $(foreach P,$(WITH_EITHER),clean.$P)

distclean:: $(foreach P,$(WITH_EITHER),distclean.$P)

with-bootstrapping-compiler: \
    $(foreach P,$(WITH_BOOTSTRAPPING_COMPILER),with-bootstrapping-compiler.$P)

with-stage-2: $(foreach P,$(WITH_STAGE2),with-stage-2.$P)
	$(MAKE) -C haddock install-inplace

install:: $(foreach P,$(filter-out $(DO_NOT_INSTALL),$(WITH_STAGE2)),install.$P)

$(foreach P,$(WITH_EITHER),clean.$P): \
clean.%:
	$(MAKE) -C $* clean

$(foreach P,$(WITH_EITHER),distclean.$P): \
distclean.%:
	$(MAKE) -C $* distclean

$(foreach P,$(WITH_BOOTSTRAPPING_COMPILER),with-bootstrapping-compiler.$P): \
with-bootstrapping-compiler.%:
	$(MAKE) -C $* with-bootstrapping-compiler

$(foreach P,$(WITH_STAGE2),with-stage-2.$P): \
with-stage-2.%:
	$(MAKE) -C $* with-stage-2

$(foreach P,$(WITH_STAGE2),install.$P): \
install.%:
	$(MAKE) -C $* install

$(foreach P,$(WITH_STAGE2),binary-dist.$P): \
binary-dist.%:
	$(MAKE) -C $* binary-dist WHERE_AM_I=$(WHERE_AM_I)/$*

=== libraries/Cabal/Makefile ===

VERSION=1.10.1.0

#KIND=devel
KIND=rc
#KIND=cabal-latest

PREFIX=/usr/local
HC=ghc
GHCFLAGS=-Wall

all: build

# build the library itself

SOURCES=Distribution/*.hs Distribution/Simple/*.hs Distribution/PackageDescription/*.hs Distribution/Simple/GHC/*.hs Distribution/Simple/Build/*.hs Distribution/Compat/*.hs Distribution/Simple/Program/*.hs
CONFIG_STAMP=dist/setup-config
BUILD_STAMP=dist/build/libHSCabal-$(VERSION).a
HADDOCK_STAMP=dist/doc/html/Cabal/index.html
USERGUIDE_STAMP=dist/doc/users-guide/index.html
SDIST_STAMP=dist/Cabal-$(VERSION).tar.gz
DISTLOC=dist/release
DIST_STAMP=$(DISTLOC)/Cabal-$(VERSION).tar.gz

COMMA=,

setup: $(SOURCES) Setup.hs
	-mkdir -p dist/setup
	$(HC) $(GHCFLAGS) --make -i. -odir dist/setup -hidir dist/setup Setup.hs -o setup

Setup-nhc:
	hmake -nhc98 -package base -prelude Setup

$(CONFIG_STAMP): setup Cabal.cabal
	./setup configure --with-compiler=$(HC) --prefix=$(PREFIX)

build: $(BUILD_STAMP)
$(BUILD_STAMP): $(CONFIG_STAMP) $(SOURCES)
	./setup build

install: $(BUILD_STAMP)
	./setup install

hugsbootstrap:
	rm -rf dist/tmp dist/hugs
	mkdir -p dist/tmp
	mkdir dist/hugs
	cp -r Distribution dist/tmp
	hugs-package dist/tmp dist/hugs
	cp Setup.lhs Cabal.cabal dist/hugs

hugsinstall: hugsbootstrap
	cd dist/hugs && ./Setup.lhs configure --hugs
	cd dist/hugs && ./Setup.lhs build
	cd dist/hugs && ./Setup.lhs install

# documentation...

haddock: $(HADDOCK_STAMP)
$(HADDOCK_STAMP) : $(CONFIG_STAMP) $(BUILD_STAMP)
	./setup haddock

PANDOC=pandoc
PANDOC_OPTIONS= \
	--standalone \
	--smart \
	--css=$(PANDOC_HTML_CSS)
PANDOC_HTML_OUTDIR=dist/doc/users-guide/
PANDOC_HTML_CSS=Cabal.css

users-guide: $(USERGUIDE_STAMP)
$(USERGUIDE_STAMP) : doc/Cabal.markdown
	mkdir -p dist/doc/users-guide/
	$(PANDOC) $(PANDOC_OPTIONS) --from=markdown --to=html $< --output $@
	cp doc/$(PANDOC_HTML_CSS) $(PANDOC_HTML_OUTDIR)

docs: haddock users-guide

clean:
	rm -rf dist/
	rm -f setup

# testing...

moduleTest: tests/ModuleTest.hs tests/PackageDescriptionTests.hs
	mkdir -p dist/test
	$(HC) --make -Wall -DDEBUG -odir dist/test -hidir dist/test \
		-itests tests/ModuleTest.hs -o moduleTest

#tests: moduleTest clean
#	cd tests/A && $(MAKE) clean
#	cd tests/HUnit-1.0 && $(MAKE) clean
#	cd tests/A && $(MAKE)
#	cd tests/HUnit-1.0 && $(MAKE)

#check:
#	rm -f moduleTest
#	$(MAKE) moduleTest
#	./moduleTest

# distribution...

$(SDIST_STAMP) : $(BUILD_STAMP)
	./setup sdist

dist: $(DIST_STAMP)
$(DIST_STAMP) : $(HADDOCK_STAMP) $(USERGUIDE_STAMP) $(SDIST_STAMP)
	rm -rf $(DISTLOC)
	mkdir $(DISTLOC)
	tar -xzf $(SDIST_STAMP) -C $(DISTLOC)/
	mkdir $(DISTLOC)/Cabal-$(VERSION)/doc
	cp -r dist/doc/html $(DISTLOC)/Cabal-$(VERSION)/doc/API
	cp -r dist/doc/users-guide $(DISTLOC)/Cabal-$(VERSION)/doc/
	cp changelog $(DISTLOC)/Cabal-$(VERSION)/
	tar -C $(DISTLOC) -c Cabal-$(VERSION) -zf $(DISTLOC)/Cabal-$(VERSION).tar.gz
	mv $(DISTLOC)/Cabal-$(VERSION)/doc $(DISTLOC)/
	mv $(DISTLOC)/Cabal-$(VERSION)/changelog $(DISTLOC)/
	rm -r $(DISTLOC)/Cabal-$(VERSION)/
	@echo "Cabal tarball built: $(DIST_STAMP)"
	@echo "Release fileset prepared: $(DISTLOC)/"

release: $(DIST_STAMP)
	scp -r $(DISTLOC) haskell.org:/srv/web/haskell.org/cabal/release/cabal-$(VERSION)
	ssh haskell.org 'cd /srv/web/haskell.org/cabal/release && rm -f $(KIND) && ln -s cabal-$(VERSION) $(KIND)'

# tags...

TAGSSRCDIRS = Distribution Language
tags TAGS: $(SOURCES)
	find $(TAGSSRCDIRS) -name \*.\*hs | xargs hasktags

=== libraries/containers/benchmarks/Makefile ===
package := containers
version := $(shell awk '/^version:/{print $$2}' ../$(package).cabal)
lib := ../dist/build/libHS$(package)-$(version).a

programs := bench

bench: Benchmarks.hs ../Data/Map.hs
	ghc -DTESTING -cpp -O2 --make -fforce-recomp -i.. -o bench Benchmarks.hs

.PHONY: run-bench
run-bench: bench
	./bench +RTS -K10M

.PHONY: clean
clean:
	-find . \( -name '*.o' -o -name '*.hi' \) -exec rm {} \;
	-rm -f $(programs)

=== libraries/time/test/Makefile ===
GHC = ghc
GHCFLAGS = -package time

default:
	make CurrentTime.run ShowDST.run test

TestMonthDay: TestMonthDay.o
	$(GHC) $(GHCFLAGS) $^ -o $@

ConvertBack: ConvertBack.o
	$(GHC) $(GHCFLAGS) $^ -o $@

TestCalendars: TestCalendars.o
	$(GHC) $(GHCFLAGS) $^ -o $@

TestTime: TestTime.o
	$(GHC) $(GHCFLAGS) $^ -o $@

LongWeekYears: LongWeekYears.o
	$(GHC) $(GHCFLAGS) $^ -o $@

ClipDates: ClipDates.o
	$(GHC) $(GHCFLAGS) $^ -o $@

AddDays: AddDays.o
	$(GHC) $(GHCFLAGS) $^ -o $@

TestFormat: TestFormat.o TestFormatStuff.o
	$(GHC) $(GHCFLAGS) $^ -o $@

TestFormatStuff.o: TestFormatStuff.c TestFormatStuff.h
	gcc -o $@ -c $<

TestParseDAT: TestParseDAT.o
	$(GHC) $(GHCFLAGS) $^ -o $@

TestEaster: TestEaster.o
	$(GHC) $(GHCFLAGS) $^ -o $@

CurrentTime: CurrentTime.o
	$(GHC) $(GHCFLAGS) $^ -o $@

ShowDST: ShowDST.o
	$(GHC) $(GHCFLAGS) $^ -o $@

TimeZone: TimeZone.o
	$(GHC) $(GHCFLAGS) $^ -o $@

TimeZone.ref: FORCE
	date +%z > $@

TestParseTime: TestParseTime.o
	$(GHC) $(GHCFLAGS) -package QuickCheck $^ -o $@

test:	\
	TestMonthDay.diff	\
	ConvertBack.diff0	\
	TestCalendars.diff	\
	TestTime.diff	\
	LongWeekYears.diff	\
	ClipDates.diff	\
	AddDays.diff	\
	TimeZone.diff	\
	TestFormat.diff0	\
	TestParseDAT.diff	\
	TestEaster.diff	\
#	TestParseTime.run \
	UseCases.o

clean:
	rm -rf TestMonthDay ConvertBack TestCalendars TestTime LongWeekYears ClipDates	\
	AddDays TestFormat TestParseDAT TestEaster CurrentTime ShowDST TimeZone TimeZone.ref TestParseTime \
        *.out *.o *.hi Makefile.bak

%.diff: %.ref %.out
	diff -u $^

%.diff0: %.out
	echo -n | diff -u - $^

%.out: %
	./$< > $@

%.run: %
	./$<

%.hi: %.o
	@:

%.o: %.hs
	$(GHC) $(GHCFLAGS) -c $< -o $@

%.o: %.lhs
	$(GHC) $(GHCFLAGS) -c $< -o $@

FORCE:

.SECONDARY:

# TestTime.o TestFormat.o CurrentTime.o ShowDST.o TimeZone.o: $(patsubst %.hs,%.hi,$(SRCS))

TestFixed.o: ../Data/Fixed.hi

=== debian/changelog ===
ghc (7.0.4-8ubuntu1) precise; urgency=low

  * Merge with Debian, remaining changes:
    + Pass --hash-style=both --no-copy-dt-needed-entries --as-needed to the
    linker.
  * Use dh-autoreconf

 -- Iain Lane <laney@ubuntu.com>  Mon, 31 Oct 2011 13:31:12 +0000

ghc (7.0.4-8) unstable; urgency=low

  * Remove ghci support on powerpc (Closes: #631073)

 -- Joachim Breitner <nomeata@debian.org>  Sun, 30 Oct 2011 17:56:23 +0100

ghc (7.0.4-7) unstable; urgency=low

  [ Joachim Breitner ]
  * patches/configure-s390x: Add s390x to the list of known architectures.
  * add armhf in debian/rules (Patch by Riku Voipio, Closes: #640811)

  [ Iain Lane ]
  * Handle linker scripts for which dlopen returns "file too short" and/or
    which contain INPUT statements (for example libncurses.so) (Closes:
    #644591)
  * Standards-Version → 3.9.2, no changes required 

 -- Iain Lane <laney@debian.org>  Tue, 18 Oct 2011 17:09:39 +0100

ghc (7.0.4-6) unstable; urgency=low

  * Fix #609445 by actually removing the patch for #566331, not needed any
    more since this upstream commit:

      Sat Jul 31 12:55:06 BST 2010  Ian Lynagh <igloo@earth.li>
      * Expose the functions haddock needs even when haddock is disabled; #3558


 -- Joachim Breitner <nomeata@debian.org>  Wed, 31 Aug 2011 08:44:33 +0200

ghc (7.0.4-5) unstable; urgency=low

  * Remove ghc-doc dependency on ghc, it did not have the desired effect.
    Instead call ghc-pkg recache in ghc-doc’s trigger as well. 
  * Fix missing instance documentation (Closes: #609445)
    This was a Debian-specific regression, introduced in the fix for #566331
    or later caused by it, and fixed by building haddock with -DGHCI.

 -- Joachim Breitner <nomeata@debian.org>  Tue, 30 Aug 2011 21:48:43 +0200

ghc (7.0.4-4) unstable; urgency=low

  * Let ghc-doc depend on ghc. It already does via ghc-haddock, making this
    explicit ensures that the triggers run in the right order. 
  * debian/patches/hash-version-number: Include the upstream version number in
    the ABI hash. We do need to recompile everything, even after a minor ghc
    upgrade. This allows to use the same mechanism to ensure correctness and
    detect that we need to recompile something as for other kind of
    recompilations. (Closes: #633828)

 -- Joachim Breitner <nomeata@debian.org>  Sat, 16 Jul 2011 11:23:09 +0200

ghc (7.0.4-3) unstable; urgency=low

  * Employ similar symlink work-around to merge /var/lib/ghc-*/package.conf.d
    into /var/lib/ghc/package.conf.d. Also remove version number from
    /usr/lib/ghc path.

 -- Joachim Breitner <nomeata@debian.org>  Mon, 11 Jul 2011 13:13:45 +0200

ghc (7.0.4-2) unstable; urgency=low

  * Fix ghc-ghci existance check logic 

 -- Joachim Breitner <nomeata@debian.org>  Sun, 10 Jul 2011 15:23:55 +0200

ghc (7.0.4-1) unstable; urgency=low

  * New upstream release (Closes: #622731)

 -- Joachim Breitner <nomeata@debian.org>  Sat, 09 Jul 2011 19:50:41 +0200

ghc (7.0.3-2) unstable; urgency=low

  * Mention correct haddock version in package description.
  * Install .haddock files under /usr/lib/ghc-doc/haddock, a path valid across
    ghc-versions. Also move them to the ghc-doc package.
  * In ghc-doc.prerm, do a better job of cleaning
    /usr/share/doc/ghc-doc/html/libraries of files generated when creating the
    haddock index.
  * Make Provides: ghc-ghci dependent on existence of ghci binary
    (Closes: #629038)
  * Make ghc-haddock depend on the exact version of ghc, just to be on the
    safe side. (Closes: #539312) 

 -- Joachim Breitner <nomeata@debian.org>  Sat, 18 Jun 2011 21:07:06 +0200

=== debian/control ===
Source: ghc
Section: haskell
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Joachim Breitner <nomeata@debian.org>
Standards-Version: 3.9.2
Build-Depends:
  debhelper (>= 7),
  dh-autoreconf,
  libgmp-dev,
  devscripts,
  ghc,
  grep-dctrl,
  autotools-dev,
  gcc (>= 4:4.2),
  libffi-dev,
  pkg-config,
  xsltproc,
  docbook-xsl,
  docbook-xml,
  binutils (>= 2.19.51.20090508) [arm armel],
  libncurses5-dev
Build-Conflicts:
  ccache
Homepage: http://haskell.org/ghc/

Package: ghc
Architecture: any
Depends: gcc (>= 4:4.2), libgmp-dev, libffi-dev, libbsd-dev, libc6-dev, ${shlibs:Depends}, ${misc:Depends}
Provides: haskell-compiler, ${provided-devs}, ${haskell:Provides}, ${ghci}
Replaces: ghc6 (<< 7)
Conflicts: ghc6 (<< 7)
Breaks: cabal-install (<< 0.8.0), haskell-devscripts (<< 0.6.19), ghc-doc (<= 6.12.1-8)
Suggests: perl, ghc-prof, ghc-doc, haskell-doc
Description: The Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.

Package: ghc-prof
Architecture: any
Provides: ${provided-profs}, ${haskell:Provides}
Depends: ghc (= ${binary:Version}), ${misc:Depends}
Replaces: ghc6-prof (<< 7)
Conflicts: ghc6-prof (<< 7)
Description: Profiling libraries for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package contains additional profiling libraries. They are only needed,
 if you want to take a closer look on where exactly your program burns CPU
 cycles.

Package: ghc-doc
Section: doc
Architecture: all
Suggests: haskell-doc
Provides: ${provided-docs}
Replaces: ghc6-doc (<< 7)
Conflicts: ghc6-doc (<< 7), ghc (<= 7.0.3-1)
Depends: ${haddock:Depends}, ${misc:Depends}, perl
Description: Documentation for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package includes HTML, DVI and PS versions of the SGML-based
 documentation around GHC.

Package: ghc-dynamic
Architecture: i386 amd64
Depends: ghc (= ${binary:Version}), ${misc:Depends}
Description: Dynamic libraries for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package has dynamically linkable, shared versions of the
 libraries included with GHC.  Currently, they are available only on
 i386 and amd64 architectures.

Package: ghc-haddock
Architecture: any
Provides: haddock, ${haddock:Provides}
Conflicts: haddock
Depends: ghc (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Homepage: http://www.haskell.org/haddock/
Description: Documentation tool for annotated Haskell source code
 Haddock is a tool for automatically generating documentation from
 annotated Haskell source code.  It is primary intended for documenting
 libraries, but it should be useful for any kind of Haskell code.
 .
 Haddock lets you write documentation annotations next to the
 definitions of functions and types in the source code, in a syntax
 that is easy on the eye when writing the source code (no heavyweight
 mark-up).  The documentation generated by Haddock is fully hyperlinked:
 click on a type name in a type signature to go straight to the
 definition, and documentation, for that type.
 .
 Haddock can generate documentation in multiple formats; currently HTML
 is implemented, and there is partial support for generating DocBook.
 .
 This package contains Haddock version 2.9.2.

Package: ghc6
Architecture: all
Depends: ghc, ${misc:Depends}
Description: transitional dummy package
 This package ensures a smooth transition from the package name ghc6 to the
 package name ghc, and can safely be removed.

Package: ghc6-doc
Architecture: all
Depends: ghc-doc, ${misc:Depends}
Section: doc
Description: transitional dummy package
 This package ensures a smooth transition from the package name ghc6-doc to the
 package name ghc-doc, and can safely be removed.

Package: ghc6-prof
Architecture: all
Depends: ghc-prof, ${misc:Depends}
Description: transitional dummy package
 This package ensures a smooth transition from the package name ghc6-prof to the
 package name ghc-prof, and can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# This file is public domain software, originally written by Joey Hess.
#
# This version is for a multibinary package. It also allows you to build any
# of the binary packages independantly, via binary-<package> targets.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Set a dummy HOME variable upon build. Some build daemons do not set HOME, but
# ghc-cabal expects it to be available.
export HOME = /homedoesnotexistatbuildtime

# From /usr/share/doc/autotools-dev/examples/rules.gz:
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
# Commented out for now.  The build scripts don't recognise i486 as an
# architecture and cross compiling isn't supported anyway.
#ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
#  confflags += --build $(DEB_HOST_GNU_TYPE)
#else
#  confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
#endif

ProjectVersion=$(shell awk -F\' "/^PACKAGE_VERSION='[0-9.]+'\$$/ { print \$$2 }" configure)

GHC=$(firstword $(shell bash -c "type -p ghc"))
EXTRA_CONFIGURE_FLAGS=--with-ghc="$(GHC)"
BUILD_HADDOCK_DOCS=YES

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	dh_autoreconf

	touch configure

	rm -f mk/build.mk
	echo "SRC_HC_OPTS += -lffi -optl-pthread" >> mk/build.mk
	echo "HADDOCK_DOCS := YES" >> mk/build.mk
	echo "XSLTPROC_OPTS += --nonet" >> mk/build.mk
ifneq (,$(findstring $(DEB_HOST_ARCH), i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc))
	echo "GhcUnregisterised=NO" >> mk/build.mk
else
	echo "GhcUnregisterised=YES" >> mk/build.mk
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), kfreebsd-i386 kfreebsd-amd64))
	echo "GhcWithInterpreter=YES" >> mk/build.mk
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), arm armel armhf alpha ia64))
	echo "UseLibFFIForAdjustors=YES" >> mk/build.mk
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), arm armel armhf))
	echo "SRC_HC_OPTS     += -optc-mlong-calls" >> mk/build.mk
endif
# proper fix for #360177
ifeq (ppc64,$(DEB_HOST_ARCH))
	echo "SRC_HC_OPTS += -optc-mminimal-toc" >> mk/build.mk
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
#	echo "GhcStage1HcOpts += -DDEBUG" >> mk/build.mk
#	echo "GhcStage2HcOpts += -DDEBUG" >> mk/build.mk
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -Rghc-timing -DDEBUG" >> mk/build.mk
#	echo "GhcLibHcOpts  += -O -dcore-lint -keep-hc-files " >> mk/build.mk
	echo "SplitObjs     = NO" >> mk/build.mk
	echo "STRIP         = :" >> mk/build.mk
endif
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -O0" >> mk/build.mk
	# This breaks the build - to be investigated:
	# echo "GhcLibHcOpts  += -O0" >> mk/build.mk
	echo "GhcRtsCcOpts  += -O0" >> mk/build.mk
endif
	# We can't do this with a configure flag in 6.8.1 as libdir is not
	# defined at the point at which we := it
	echo 'ghclibdir := $${libdir}/ghc' >> mk/build.mk
	echo 'bindir  := $${ghclibdir}/bin' >> mk/build.mk
	echo 'ghclibexecdir := $${ghclibdir}/lib' >> mk/build.mk
	# docdir doesn't have a configure flag, and unfortunately
	# we also need to explicitly define all of its dependents as they
	# are set with :=
	echo 'docdir  := $$(datarootdir)/doc/ghc-doc' >> mk/build.mk
	echo 'htmldir := $$(docdir)'                   >> mk/build.mk
	echo 'dvidir  := $$(docdir)'                   >> mk/build.mk
	echo 'pdfdir  := $$(docdir)'                   >> mk/build.mk
	echo 'psdir   := $$(docdir)'                   >> mk/build.mk
	rm -f config.sub
	rm -f config.guess
	ln -s /usr/share/misc/config.sub .
	ln -s /usr/share/misc/config.guess .
	./configure $(confflags) --prefix=/usr $(EXTRA_CONFIGURE_FLAGS)

	touch $@

build: build-stamp
build-stamp: configure-stamp
	dh_testdir
	$(MAKE) $(MAKEFLAGS)

	# Do some very simple tests that the compiler actually works
	rm -rf debian/testghc
	mkdir debian/testghc
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo -O2
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*

# build haddock separately and hard code paths according to install paths
	mkdir -p debian/haddock-build
	cp -r utils/haddock debian/haddock-build
	cd debian/haddock-build/haddock; \
		../../../inplace/bin/ghc-stage2 --make Setup.lhs; \
		./Setup configure --prefix=/usr --with-compiler=../../../inplace/bin/ghc-stage2 \
			--package-db=../../../inplace/lib/package.conf.d/ \
			--htmldir=/usr/share/doc/ghc-haddock/html/ ; \
		./Setup build

	touch $@

FILES = \( -type f -o -type l \)
PROF_FILE = \( -name "*.p_*" -o -name "lib*_p.a" \)
DYNAMIC_FILE = \( -name "*.dyn_hi" -o -name lib*.so \)

install: install-stamp
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_prep

	# Install the basic stuff
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install

	# Delete all the library LICENSE files
	rm -f debian/tmp/usr/share/doc/ghc-doc/html/libraries/*/LICENSE

	# Generate lintian overrides
	mkdir -p debian/tmp/usr/share/lintian/overrides
	echo "ghc binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
	echo "ghc: extra-license-file `cl debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.dyn_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
	echo "ghc-prof binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.p_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc-prof

	# Sort out the package.conf files
	mkdir -p debian/tmp/var/lib/ghc
	# Old directories for symlink-workaround. Remove once all libraries use new path
	mkdir -p debian/tmp/var/lib/ghc-7.0.3/package.conf.d
	mkdir -p debian/tmp/var/lib/ghc-7.0.4/package.conf.d
	mv debian/tmp/usr/lib/ghc/package.conf.d \
	   debian/tmp/var/lib/ghc/
	rm debian/tmp/var/lib/ghc/package.conf.d/package.cache
	chmod +x debian/provided_substvars
	debian/provided_substvars
	sed -ri 's,^haddock-interfaces: /.*?/libraries/,haddock-interfaces: /usr/lib/ghc-doc/haddock/,' debian/tmp/var/lib/ghc/package.conf.d/*.conf

	# Remove haddock as built within the ghc tree
	rm -f debian/tmp/usr/lib/ghc/bin/haddock \
	      debian/tmp/usr/lib/ghc/bin/haddock-$(ProjectVersion) \
	      debian/tmp/usr/lib/ghc/lib/haddock
	rm -rf debian/tmp/usr/lib/ghc/html

	# Sort out the binaries
	mkdir -p debian/tmp/usr/bin
	if inplace/bin/ghc-stage2 --info | grep '"Have interpreter","NO"'; then \
	    cd debian/tmp/usr/lib/ghc ;rm -f bin/ghci* bin/runghc* bin/runhaskell*; \
	fi
	cd debian/tmp/usr/lib/ghc/bin && \
	    for f in *; \
	    do ln -s /usr/lib/ghc/bin/$$f \
	             ../../../bin/$${f}; \
	    done
	sed -i 's,topdir="/usr/lib,topdir="/var/lib,' debian/tmp/usr/lib/ghc/bin/ghc-pkg-$(ProjectVersion)
	cd debian/haddock-build/haddock; ./Setup copy --dest=../../tmp

	# Check if we have a ghci binary
	if test -e debian/tmp/usr/lib/ghc/bin/ghci-$(ProjectVersion); then \
	    echo 'ghci=ghc-ghci' >> debian/ghc.substvars ; fi

	# Add haddock substvars
	echo "haddock:Depends=$$(debian/tmp/usr/bin/haddock --interface-version)" >> debian/ghc-doc.substvars
	echo "haddock:Provides=$$(debian/tmp/usr/bin/haddock --interface-version)" >> debian/ghc-haddock.substvars

ifeq (YES,$(BUILD_HADDOCK_DOCS))
	mkdir -p debian/tmp/usr/lib/ghc-doc
	cp debian/gen_contents_index debian/tmp/usr/lib/ghc-doc/
	chmod +x debian/tmp/usr/lib/ghc-doc/gen_contents_index
	mkdir debian/tmp/usr/lib/ghc-doc/haddock/

## ghc 7.2.2

=== libraries/Cabal/cabal/Makefile ===

VERSION=1.11.2

#KIND=devel
KIND=rc
#KIND=cabal-latest

PREFIX=/usr/local
HC=ghc
GHCFLAGS=-Wall

all: build

# build the library itself

SOURCES=Distribution/*.hs Distribution/Simple/*.hs Distribution/PackageDescription/*.hs Distribution/Simple/GHC/*.hs Distribution/Simple/Build/*.hs Distribution/Compat/*.hs Distribution/Simple/Program/*.hs
CONFIG_STAMP=dist/setup-config
BUILD_STAMP=dist/build/libHSCabal-$(VERSION).a
HADDOCK_STAMP=dist/doc/html/Cabal/index.html
USERGUIDE_STAMP=dist/doc/users-guide/index.html
SDIST_STAMP=dist/Cabal-$(VERSION).tar.gz
DISTLOC=dist/release
DIST_STAMP=$(DISTLOC)/Cabal-$(VERSION).tar.gz

COMMA=,

setup: $(SOURCES) Setup.hs
	-mkdir -p dist/setup
	$(HC) $(GHCFLAGS) --make -i. -odir dist/setup -hidir dist/setup Setup.hs -o setup

Setup-nhc:
	hmake -nhc98 -package base -prelude Setup

$(CONFIG_STAMP): setup Cabal.cabal
	./setup configure --with-compiler=$(HC) --prefix=$(PREFIX)

build: $(BUILD_STAMP)
$(BUILD_STAMP): $(CONFIG_STAMP) $(SOURCES)
	./setup build

install: $(BUILD_STAMP)
	./setup install

hugsbootstrap:
	rm -rf dist/tmp dist/hugs
	mkdir -p dist/tmp
	mkdir dist/hugs
	cp -r Distribution dist/tmp
	hugs-package dist/tmp dist/hugs
	cp Setup.lhs Cabal.cabal dist/hugs

hugsinstall: hugsbootstrap
	cd dist/hugs && ./Setup.lhs configure --hugs
	cd dist/hugs && ./Setup.lhs build
	cd dist/hugs && ./Setup.lhs install

# documentation...

haddock: $(HADDOCK_STAMP)
$(HADDOCK_STAMP) : $(CONFIG_STAMP) $(BUILD_STAMP)
	./setup haddock

PANDOC=pandoc
PANDOC_OPTIONS= \
	--standalone \
	--smart \
	--css=$(PANDOC_HTML_CSS)
PANDOC_HTML_OUTDIR=dist/doc/users-guide
PANDOC_HTML_CSS=Cabal.css

users-guide: $(USERGUIDE_STAMP) doc/*.markdown
$(USERGUIDE_STAMP): doc/*.markdown
	mkdir -p $(PANDOC_HTML_OUTDIR)
	for file in $^; do $(PANDOC) $(PANDOC_OPTIONS) --from=markdown --to=html --output $(PANDOC_HTML_OUTDIR)/$$(basename $${file} .markdown).html $${file}; done
	cp doc/$(PANDOC_HTML_CSS) $(PANDOC_HTML_OUTDIR)

docs: haddock users-guide

clean:
	rm -rf dist/
	rm -f setup

# testing...

moduleTest: tests/ModuleTest.hs tests/PackageDescriptionTests.hs
	mkdir -p dist/test
	$(HC) --make -Wall -DDEBUG -odir dist/test -hidir dist/test \
		-itests tests/ModuleTest.hs -o moduleTest

#tests: moduleTest clean
#	cd tests/A && $(MAKE) clean
#	cd tests/HUnit-1.0 && $(MAKE) clean
#	cd tests/A && $(MAKE)
#	cd tests/HUnit-1.0 && $(MAKE)

#check:
#	rm -f moduleTest
#	$(MAKE) moduleTest
#	./moduleTest

# distribution...

$(SDIST_STAMP) : $(BUILD_STAMP)
	./setup sdist

dist: $(DIST_STAMP)
$(DIST_STAMP) : $(HADDOCK_STAMP) $(USERGUIDE_STAMP) $(SDIST_STAMP)
	rm -rf $(DISTLOC)
	mkdir $(DISTLOC)
	tar -xzf $(SDIST_STAMP) -C $(DISTLOC)/
	mkdir $(DISTLOC)/Cabal-$(VERSION)/doc
	cp -r dist/doc/html $(DISTLOC)/Cabal-$(VERSION)/doc/API
	cp -r dist/doc/users-guide $(DISTLOC)/Cabal-$(VERSION)/doc/
	cp changelog $(DISTLOC)/Cabal-$(VERSION)/
	tar -C $(DISTLOC) -c Cabal-$(VERSION) -zf $(DISTLOC)/Cabal-$(VERSION).tar.gz
	mv $(DISTLOC)/Cabal-$(VERSION)/doc $(DISTLOC)/
	mv $(DISTLOC)/Cabal-$(VERSION)/changelog $(DISTLOC)/
	rm -r $(DISTLOC)/Cabal-$(VERSION)/
	@echo "Cabal tarball built: $(DIST_STAMP)"
	@echo "Release fileset prepared: $(DISTLOC)/"

release: $(DIST_STAMP)
	scp -r $(DISTLOC) haskell.org:/srv/web/haskell.org/cabal/release/cabal-$(VERSION)
	ssh haskell.org 'cd /srv/web/haskell.org/cabal/release && rm -f $(KIND) && ln -s cabal-$(VERSION) $(KIND)'

# tags...

TAGSSRCDIRS = Distribution Language
tags TAGS: $(SOURCES)
	find $(TAGSSRCDIRS) -name \*.\*hs | xargs hasktags

=== debian/changelog ===
ghc (7.2.2-1) experimental; urgency=low

  * New upstream release
  * Call autoconf and remove configure in clean, to avoid having an
    autoreconf-patch in debian/patches. 
  * Drop patches/hash-version-number, applied upstream
  * Drop improve_linker_script_handling, applied upstream

 -- Joachim Breitner <nomeata@debian.org>  Sat, 19 Nov 2011 18:34:17 +0100

ghc (7.2.1-1) experimental; urgency=low

  * New upstream release. 

 -- Joachim Breitner <nomeata@debian.org>  Tue, 23 Aug 2011 20:58:31 +0200

ghc (7.2.0.20110728-1) experimental; urgency=low

  * Remove ghc-doc dependency on ghc, it did not have the desired effect.
    Instead call ghc-pkg recache in ghc-doc’s trigger as well. 
  * Install 7.2.1-rc1 to experimental. 
  * Undo the symlink-workarounds introduced in 7.0.4-3. The -doc work-around
    is still needed, as the haddock interface version did not change.

 -- Joachim Breitner <nomeata@debian.org>  Sat, 06 Aug 2011 19:50:04 +0200

ghc (7.0.4-9) UNRELEASED; urgency=low

  * Suggest llvm package

 -- Joachim Breitner <nomeata@debian.org>  Thu, 10 Nov 2011 19:19:41 +0100

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,17 @@
 Source: ghc
 Section: haskell
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
 Uploaders: Joachim Breitner <nomeata@debian.org>
 Standards-Version: 3.9.2
 Build-Depends:
   debhelper (>= 7),
-  dh-autoreconf,
   libgmp-dev,
   devscripts,
   ghc,
   grep-dctrl,
   autotools-dev,
+  autoconf,
   gcc (>= 4:4.2),
   libffi-dev,
   pkg-config,
@@ -32,7 +31,7 @@
 Replaces: ghc6 (<< 7)
 Conflicts: ghc6 (<< 7)
 Breaks: cabal-install (<< 0.8.0), haskell-devscripts (<< 0.6.19), ghc-doc (<= 6.12.1-8)
-Suggests: perl, ghc-prof, ghc-doc, haskell-doc
+Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm
 Description: The Glasgow Haskell Compilation system
  The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
  Haskell.

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,7 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+
 
 # Set a dummy HOME variable upon build. Some build daemons do not set HOME, but
 # ghc-cabal expects it to be available.
@@ -24,7 +25,7 @@
 #  confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
 #endif
 
-ProjectVersion=$(shell awk -F\' "/^PACKAGE_VERSION='[0-9.]+'\$$/ { print \$$2 }" configure)
+ProjectVersion=$(shell cat VERSION)
 
 GHC=$(firstword $(shell bash -c "type -p ghc"))
 EXTRA_CONFIGURE_FLAGS=--with-ghc="$(GHC)"
@@ -38,9 +39,8 @@
 configure: configure-stamp
 configure-stamp:
 	dh_testdir
-	dh_autoreconf
 
-	touch configure
+	autoconf
 
 	rm -f mk/build.mk
 	echo "SRC_HC_OPTS += -lffi -optl-pthread" >> mk/build.mk
@@ -155,8 +155,6 @@
 	# Sort out the package.conf files
 	mkdir -p debian/tmp/var/lib/ghc
 	# Old directories for symlink-workaround. Remove once all libraries use new path
-	mkdir -p debian/tmp/var/lib/ghc-7.0.3/package.conf.d
-	mkdir -p debian/tmp/var/lib/ghc-7.0.4/package.conf.d
 	mv debian/tmp/usr/lib/ghc/package.conf.d \
 	   debian/tmp/var/lib/ghc/
 	rm debian/tmp/var/lib/ghc/package.conf.d/package.cache
@@ -196,3 +194,5 @@
 	cp debian/gen_contents_index debian/tmp/usr/lib/ghc-doc/
 	chmod +x debian/tmp/usr/lib/ghc-doc/gen_contents_index
 	mkdir debian/tmp/usr/lib/ghc-doc/haddock/
+	for f in `find debian/tmp/usr/share/doc/ghc-doc/html/libraries/ -maxdepth 1 -mindepth 1 -type d`; do \
+	    mkdir debian/tmp/usr/lib/ghc-doc/haddock/`basename $$f` ; \
